import { RuleInstance, ValidationError } from './api';
export declare class Validator {
    readonly rules: RuleInstance[];
    protected readonly allowNull: boolean;
    protected readonly allowUndefined: boolean;
    constructor(rules: RuleInstance[], allowNull: boolean, allowUndefined: boolean);
    protected withRule(rule: RuleInstance): this;
    optional(): this;
    orNull(): this;
    orUndefined(): this;
    describe(): string;
    test(value: any): boolean;
    check(value: any, name?: string): void;
    testAll(value: any, name?: string): ValidationError[];
    private getFailingRules;
    private getRuleError;
}
