var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
System.register("api", [], function (exports_1, context_1) {
    "use strict";
    var ValidationError;
    var __moduleName = context_1 && context_1.id;
    return {
        setters: [],
        execute: function () {
            /**
             * Exception class thrown or returned when validation errors are encountered.
             */
            ValidationError = /** @class */ (function (_super) {
                __extends(ValidationError, _super);
                /**
                 * Creates a new ValidationError with the given error message and failing rule.
                 *
                 * @param message the error message
                 * @param rule the failing validation rule
                 */
                function ValidationError(message, rule, variable) {
                    var _this = _super.call(this, message) || this;
                    _this.rule = rule;
                    Object.setPrototypeOf(_this, ValidationError.prototype);
                    _this.name = _this.constructor.name;
                    _this.variable = variable;
                    return _this;
                }
                return ValidationError;
            }(Error));
            exports_1("ValidationError", ValidationError);
        }
    };
});
System.register("Validator", ["api"], function (exports_2, context_2) {
    "use strict";
    var api_1, Validator;
    var __moduleName = context_2 && context_2.id;
    return {
        setters: [
            function (api_1_1) {
                api_1 = api_1_1;
            }
        ],
        execute: function () {
            Validator = /** @class */ (function () {
                function Validator(rules, allowNull, allowUndefined) {
                    this.rules = rules;
                    this.allowNull = allowNull;
                    this.allowUndefined = allowUndefined;
                }
                Validator.prototype.withRule = function (rule) {
                    return new this.constructor(this.rules.concat(rule), this.allowNull, this.allowUndefined);
                };
                Validator.prototype.optional = function () {
                    return new this.constructor(this.rules, true, true);
                };
                Validator.prototype.orNull = function () {
                    return new this.constructor(this.rules, true, this.allowUndefined);
                };
                Validator.prototype.orUndefined = function () {
                    return new this.constructor(this.rules, this.allowNull, true);
                };
                Validator.prototype.describe = function () {
                    if (this.rules.length > 0) {
                        var message = this.rules.map(function (rule) { return rule.describe(); }).join(' and ');
                        if (this.allowNull) {
                            message += ' or null';
                        }
                        if (this.allowUndefined) {
                            message += ' or undefined';
                        }
                        return message;
                    }
                    return 'any';
                };
                Validator.prototype.test = function (value) {
                    return this.getFailingRules(value).next().done === true;
                };
                Validator.prototype.check = function (value, name) {
                    var first = this.getFailingRules(value).next();
                    if (!first.done) {
                        throw this.getRuleError(first.value, name);
                    }
                };
                Validator.prototype.testAll = function (value, name) {
                    var _this = this;
                    return Array.from(this.getFailingRules(value), function (rule) { return _this.getRuleError(rule, name); });
                };
                Validator.prototype.getFailingRules = function (value) {
                    var _i, _a, rule, result;
                    return __generator(this, function (_b) {
                        switch (_b.label) {
                            case 0:
                                if (!(!(this.allowNull && value === null) && !(this.allowUndefined && value === undefined))) return [3 /*break*/, 4];
                                _i = 0, _a = this.rules;
                                _b.label = 1;
                            case 1:
                                if (!(_i < _a.length)) return [3 /*break*/, 4];
                                rule = _a[_i];
                                result = rule.test(value);
                                if (!!result) return [3 /*break*/, 3];
                                return [4 /*yield*/, rule];
                            case 2:
                                _b.sent();
                                _b.label = 3;
                            case 3:
                                _i++;
                                return [3 /*break*/, 1];
                            case 4: return [2 /*return*/];
                        }
                    });
                };
                Validator.prototype.getRuleError = function (rule, name) {
                    var message = "Expected " + rule.describe();
                    if (name) {
                        message += " for \"" + name + "\"";
                    }
                    return new api_1.ValidationError(message, rule, name);
                };
                return Validator;
            }());
            exports_2("Validator", Validator);
        }
    };
});
System.register("Validation", ["Validator"], function (exports_3, context_3) {
    "use strict";
    var Validator_1, Validation;
    var __moduleName = context_3 && context_3.id;
    function hasLength(v) {
        return typeof v === 'string' || Array.isArray(v);
    }
    function isNumeric(v) {
        return !isNaN(parseFloat(v));
    }
    function isObject(v) {
        return v && typeof v === 'object' && !Array.isArray(v);
    }
    return {
        setters: [
            function (Validator_1_1) {
                Validator_1 = Validator_1_1;
            }
        ],
        execute: function () {
            Validation = /** @class */ (function (_super) {
                __extends(Validation, _super);
                function Validation(rules, allowNull, allowUndefined, invertNext) {
                    if (allowNull === void 0) { allowNull = false; }
                    if (allowUndefined === void 0) { allowUndefined = false; }
                    if (invertNext === void 0) { invertNext = false; }
                    var _this = _super.call(this, rules, allowNull, allowUndefined) || this;
                    _this.invertNext = invertNext;
                    return _this;
                }
                Validation.prototype.withRule = function (rule) {
                    if (this.invertNext) {
                        var orig_1 = rule;
                        rule = { id: 'not', rule: orig_1, describe: function () { return "not " + orig_1.describe(); }, test: function (v) { return !orig_1.test(v); } };
                    }
                    return _super.prototype.withRule.call(this, rule);
                };
                Validation.prototype.array = function () {
                    return this.withRule({ id: 'array', describe: function () { return 'array'; }, test: function (v) { return Array.isArray(v); } });
                };
                Validation.prototype.boolean = function () {
                    return this.withRule({ id: 'boolean', describe: function () { return 'boolean'; }, test: function (v) { return typeof v === 'boolean'; } });
                };
                Validation.prototype.integer = function () {
                    return this.withRule({ id: 'integer', describe: function () { return 'integer'; }, test: function (v) { return Number.isInteger(v); } });
                };
                Validation.prototype.null = function () {
                    return this.withRule({ id: 'null', describe: function () { return 'null'; }, test: function (v) { return v === null; } });
                };
                Validation.prototype.number = function () {
                    return this.withRule({ id: 'number', describe: function () { return 'number'; }, test: function (v) { return typeof v === 'number'; } });
                };
                Validation.prototype.numeric = function () {
                    return this.withRule({ id: 'numeric', describe: function () { return 'numeric'; }, test: function (v) { return isNumeric(v); } });
                };
                Validation.prototype.object = function () {
                    return this.withRule({ id: 'object', describe: function () { return 'object'; }, test: function (v) { return isObject(v); } });
                };
                Validation.prototype.string = function () {
                    return this.withRule({ id: 'string', describe: function () { return 'string'; }, test: function (v) { return typeof v === 'string'; } });
                };
                Validation.prototype.undefined = function () {
                    return this.withRule({ id: 'undefined', describe: function () { return 'undefined'; }, test: function (v) { return v === undefined; } });
                };
                Object.defineProperty(Validation.prototype, "not", {
                    get: function () {
                        return new Validation(this.rules, this.allowNull, this.allowUndefined, true);
                    },
                    enumerable: true,
                    configurable: true
                });
                Validation.prototype.anyOf = function () {
                    var validators = [];
                    for (var _i = 0; _i < arguments.length; _i++) {
                        validators[_i] = arguments[_i];
                    }
                    return this.withRule({
                        id: 'anyOf',
                        rulesAlternatives: validators.map(function (vd) { return vd.rules; }),
                        describe: function () { return '(' + validators.map(function (vd) { return vd.describe(); }).join(' or ') + ')'; },
                        test: function (v) { return validators.some(function (vd) { return vd.test(v); }); }
                    });
                };
                Validation.prototype.equal = function (value) {
                    return this.withRule({
                        id: 'equal',
                        value: value,
                        describe: function () { return "value equal to " + JSON.stringify(value); },
                        test: function (v) { return v == value; }
                    });
                };
                Validation.prototype.exact = function (value) {
                    return this.withRule({
                        id: 'exact',
                        value: value,
                        describe: function () { return "value exactly equal to " + JSON.stringify(value); },
                        test: function (v) { return v === value; }
                    });
                };
                Validation.prototype.predicate = function (test, description) {
                    return this.withRule({
                        id: 'predicate',
                        describe: function () { return description; },
                        test: test
                    });
                };
                Validation.prototype.between = function (min, max) {
                    if (min > max) {
                        throw new Error("Invalid range constraint: minimum (" + min + ") is greater than maximum (" + max + ")");
                    }
                    return this.withRule({
                        id: 'between',
                        min: min,
                        max: max,
                        describe: function () { return "number between " + min + " and " + max; },
                        test: function (v) { return isNumeric(v) && v >= min && v <= max; }
                    });
                };
                Validation.prototype.greaterThan = function (bound) {
                    return this.withRule({
                        id: 'greaterThan',
                        bound: bound,
                        describe: function () { return "number greater than " + bound; },
                        test: function (v) { return isNumeric(v) && v > bound; }
                    });
                };
                Validation.prototype.greaterThanOrEqual = function (bound) {
                    return this.withRule({
                        id: 'greaterThanOrEqual',
                        bound: bound,
                        describe: function () { return "number greater than or equal to " + bound; },
                        test: function (v) { return isNumeric(v) && v >= bound; }
                    });
                };
                Validation.prototype.lessThan = function (bound) {
                    return this.withRule({
                        id: 'lessThan',
                        bound: bound,
                        describe: function () { return "number less than " + bound; },
                        test: function (v) { return isNumeric(v) && v < bound; }
                    });
                };
                Validation.prototype.lessThanOrEqual = function (bound) {
                    return this.withRule({
                        id: 'lessThanOrEqual',
                        bound: bound,
                        describe: function () { return "number less than or equal to " + bound; },
                        test: function (v) { return isNumeric(v) && v <= bound; }
                    });
                };
                Validation.prototype.positive = function () {
                    return this.withRule({ id: 'positive', describe: function () { return 'positive number'; }, test: function (v) { return v > 0; } });
                };
                Validation.prototype.negative = function () {
                    return this.withRule({ id: 'negative', describe: function () { return 'negative number'; }, test: function (v) { return v < 0; } });
                };
                Validation.prototype.length = function (min, max) {
                    if (max == null) {
                        return this.withRule({
                            id: 'length',
                            min: min,
                            describe: function () { return "length of " + min; },
                            test: function (v) { return hasLength(v) && v.length === min; }
                        });
                    }
                    if (min > max) {
                        throw new Error("Invalid length constraint: minimum (" + min + ") is greater than maximum (" + max + ")");
                    }
                    return this.withRule({
                        id: 'length',
                        min: min,
                        max: max,
                        describe: function () { return "length between " + min + " and " + max; },
                        test: function (v) { return hasLength(v) && v.length >= min && v.length <= max; }
                    });
                };
                Validation.prototype.minLength = function (min) {
                    return this.withRule({
                        id: 'minLength',
                        min: min,
                        describe: function () { return "minimum length of " + min; },
                        test: function (v) { return hasLength(v) && v.length >= min; }
                    });
                };
                Validation.prototype.maxLength = function (max) {
                    return this.withRule({
                        id: 'maxLength',
                        max: max,
                        describe: function () { return "maximum length of " + max; },
                        test: function (v) { return hasLength(v) && v.length <= max; }
                    });
                };
                Validation.prototype.empty = function () {
                    return this.withRule({
                        id: 'empty',
                        describe: function () { return 'zero length'; },
                        test: function (v) { return hasLength(v) && v.length === 0; }
                    });
                };
                Validation.prototype.pattern = function (regex) {
                    return this.withRule({
                        id: 'pattern',
                        regex: regex,
                        describe: function () { return "string matching " + regex; },
                        test: function (v) { return typeof v === 'string' && regex.test(v); }
                    });
                };
                Validation.prototype.contains = function (str) {
                    return this.withRule({
                        id: 'contains',
                        str: str,
                        describe: function () { return "string containing " + JSON.stringify(str); },
                        test: function (v) { return typeof v === 'string' && v.includes(str); }
                    });
                };
                Validation.prototype.startsWith = function (str) {
                    return this.withRule({
                        id: 'startsWith',
                        str: str,
                        describe: function () { return "string starting with " + JSON.stringify(str); },
                        test: function (v) { return typeof v === 'string' && v.startsWith(str); }
                    });
                };
                Validation.prototype.endsWith = function (str) {
                    return this.withRule({
                        id: 'endsWith',
                        str: str,
                        describe: function () { return "string ending with " + JSON.stringify(str); },
                        test: function (v) { return typeof v === 'string' && v.endsWith(str); }
                    });
                };
                Validation.prototype.includes = function (value) {
                    return this.withRule({
                        id: 'includes',
                        value: value,
                        describe: function () { return "array containing " + JSON.stringify(value); },
                        test: function (v) { return Array.isArray(v) && v.includes(value); }
                    });
                };
                Validation.prototype.every = function (elementValidator) {
                    return this.withRule({
                        id: 'every',
                        rules: elementValidator.rules,
                        describe: function () { return "array with every element " + elementValidator.describe(); },
                        test: function (v) { return Array.isArray(v) && v.every(function (e) { return elementValidator.test(e); }); }
                    });
                };
                Validation.prototype.some = function (elementValidator) {
                    return this.withRule({
                        id: 'some',
                        rules: elementValidator.rules,
                        describe: function () { return "array with some element " + elementValidator.describe(); },
                        test: function (v) { return Array.isArray(v) && v.some(function (e) { return elementValidator.test(e); }); }
                    });
                };
                Validation.prototype.instanceOf = function (ctor) {
                    return this.withRule({
                        id: 'instanceOf',
                        ctor: ctor,
                        describe: function () { return "instance of " + ctor.name; },
                        test: function (v) { return v instanceof ctor; }
                    });
                };
                Validation.prototype.keys = function (arrayValidator) {
                    return this.withRule({
                        id: 'keys',
                        rules: arrayValidator.rules,
                        describe: function () { return "object with keys " + arrayValidator.describe(); },
                        test: function (v) { return isObject(v) && arrayValidator.test(Object.keys(v)); }
                    });
                };
                Validation.prototype.values = function (arrayValidator) {
                    return this.withRule({
                        id: 'values',
                        rules: arrayValidator.rules,
                        describe: function () { return "object with values " + arrayValidator.describe(); },
                        test: function (v) { return isObject(v) && arrayValidator.test(Object.values(v)); }
                    });
                };
                Validation.prototype.properties = function (propertyValidator, only) {
                    if (only === void 0) { only = false; }
                    return this.withRule({
                        id: 'properties',
                        properties: propertyValidator,
                        only: only,
                        describe: function () {
                            var entries = Object.entries(propertyValidator);
                            if (!entries.length) {
                                return "object with " + (only ? 'no' : 'any') + " properties";
                            }
                            return "object with " + (only ? 'only ' : '') + "properties " + entries
                                .map(function (_a) {
                                var k = _a[0], v = _a[1];
                                return k + " (" + v.describe() + ")";
                            })
                                .join(', ');
                        },
                        test: function (o) {
                            return isObject(o) &&
                                Object.entries(propertyValidator).every(function (_a) {
                                    var k = _a[0], v = _a[1];
                                    return v.test(o[k]);
                                }) &&
                                (!only || Object.keys(o).every(function (k) { return k in propertyValidator; }));
                        }
                    });
                };
                return Validation;
            }(Validator_1.Validator));
            exports_3("Validation", Validation);
        }
    };
});
System.register("index", ["Validation", "api", "Validator"], function (exports_4, context_4) {
    "use strict";
    var Validation_1, tsfv;
    var __moduleName = context_4 && context_4.id;
    return {
        setters: [
            function (Validation_1_1) {
                Validation_1 = Validation_1_1;
                exports_4({
                    "Validation": Validation_1_1["Validation"]
                });
            },
            function (api_2_1) {
                exports_4({
                    "ValidationError": api_2_1["ValidationError"]
                });
            },
            function (Validator_2_1) {
                exports_4({
                    "Validator": Validator_2_1["Validator"]
                });
            }
        ],
        execute: function () {
            tsfv = new Validation_1.Validation([]);
            exports_4("default", tsfv);
        }
    };
});
//# sourceMappingURL=tsfv.js.map